<template>
	<div class="popup">
		
		<transition name="fade">
			<div class="loading-wrapper" v-if="loading">
				<div class="loading left">
					<div class="dot"></div>
					<div class="dot"></div>
					<div class="dot"></div>
				</div>
			</div>
		</transition>
			
		<div class="panel-container">
			
			<div class="panel" v-if="panel === 'not_logged_in'">
				<h3 class="hustle align-center">Vairus</h3>
		
				<div class="tabs flex space">
					<div class="tab current">{{getLocale('login')}}</div>
					<div class="tab" v-on:click="switchPanel('register')">{{getLocale('register')}}</div>
				</div>
				
				<input v-model="login_data.email" type="text" v-bind:placeholder="getLocale('email')"/>
				<form v-on:submit.prevent="login">
					<input v-model="login_data.password" type="password" v-bind:placeholder="getLocale('password')"/>
				</form>
				
				<div class="actions">
					<v-button
						@clicked="login"
						color="lightestazure"
						:text="getLocale('login')"
					/>
					
					<div class="align-center register"><a target="_blank" href="https://playvairus.com?recover">{{getLocale('forgot_password')}}</a></div>
				</div>
				
			</div>
			
			<div class="panel" v-if="panel === 'register'">
				<h3 class="hustle align-center">Vairus</h3>
		
				<div class="tabs flex space">
					<div class="tab" v-on:click="switchPanel('not_logged_in')">{{getLocale('login')}}</div>
					<div class="tab current" >{{getLocale('register')}}</div>
				</div>
				
				<form v-on:submit.prevent="register">
					<input v-model="register_data.username" type="text" v-bind:placeholder="getLocale('username')"/>
					<input v-model="register_data.email" type="email" v-bind:placeholder="getLocale('email')"/>
					<input v-model="register_data.password" type="password" v-bind:placeholder="getLocale('password')"/>
					<input v-model="register_data.password_repeat" type="password" v-bind:placeholder="getLocale('repeat_password')"/>
					<div class="flex">
						<input id="newsletter" v-model="register_data.newsletter" type="checkbox" />
						<label for="newsletter">{{getLocale('newsletter_agree')}}</label>
					</div>
				</form>
				
				<div class="actions flex">
					<v-button
						@clicked="register"
						color="lightestazure"
						:text="getLocale('register')"
					/>
				</div>
				
			</div>
			
			
			<div class="panel align-center" v-if="panel === 'version_not_valid'">
				<h3 class="hustle align-center">Vairus</h3>
				
				{{getLocale('invalid_version')}}<br>
			</div>
			
			<div class="panel loggedin" v-if="panel === 'logged_in'">
				<div class="flex space">
					<h3 class="hustle align-center">Vairus</h3>
					
					<div class="align-right">
						<div>Hacker</div>
						<div class="bold">{{username}}</div>
					</div>
				</div>
				
				<div class="actions flex space">
					<v-button
						class="profile-button"
						color="lightestazure"
						@clicked="openProfile"
						:text="getLocale((first_login) ? 'start' : 'profile')"
					/>
					<div class="status small-font" :class="{active : !active}" v-on:click="activate">
						<div class="toggle"></div>
					</div>
				</div>
			</div>
			
			<div class="panel loggedin" v-if="panel === 'reconnect'">
				<div class="flex space">
					<h3 class="hustle align-center">Vairus</h3>
					
					<div class="align-right">
						<div>Hacker</div>
						<div class="bold">{{username}}</div>
					</div>
				</div>
				
				<div class="actions flex space">
					<v-button
						class="profile-button"
						color="lightestazure"
						@clicked="reconnect"
						:text="getLocale('reconnect')"
					/>
				</div>
			</div>
		</div>
		
		<div class="login-error darkred-bkg" v-if="login_data.error">{{login_data.error}}</div>
		<div class="register-error darkred-bkg" v-if="register_data.error">{{register_data.error}}</div>
	</div>
</template>

<script>

var browser = browser || chrome;
import VButton from '../components/VButton.vue';

export default {
	data () { 
		return {
			loading : false,
			active : true,
			panel : 'not_logged_in',
			username : '',
			first_login : false,
			login_data : {
				email : '',
				password : '',
				error : ''
			},
			register_data : {
				username : '',
				email : '',
				password : '',
				password_repeat : '',
				newsletter : false,
				error : '',
			}
		}
	},
	mounted() {
		//Check the login status
		browser.runtime.sendMessage({type : 'check_login_status'}, function(response) {
			this.panel = response.status;
			this.username = response.username;
			this.active = response.active;
		}.bind(this));
		
		//Extension not updated
		browser.runtime.onMessage.addListener(
			function(request, sender, sendResponse) {
				if (request.type === 'version_not_valid') {
					this.panel = 'version_not_valid';
				}
			}.bind(this)
		)
	},
	methods: {
		getLocale(msg, substitution = null){
			return browser.i18n.getMessage(msg, substitution);
		},
		//Switch popup panel
		switchPanel: function (panel) {
			this.panel = panel;
			this.login_data.error = '';
			this.register_data.error = '';
		},
		//pen profile
		openProfile: function() {
			browser.tabs.create({url: '/profile/profile.html'});
		},
		//Toggle Vairus active
		activate: function() {
			this.active = !this.active;
			browser.runtime.sendMessage({type : 'activate', active : this.active});
		},
		//Validate email
		validateEmail(email) {
			var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
			return re.test(email);
		},
		//Login
		login: function(){
			this.loading = true;
			this.login_data.error = '';
			
			var data = {
				type : 'login',
				data : {
					email : this.login_data.email,
					password : this.login_data.password,
				}
			}
			
			browser.runtime.sendMessage(data, function(response) {
				if(response.success){
					this.panel = 'logged_in';
					this.username = response.message;
				}else{
					this.login_data.error = response.message;
				}
				this.loading = false;
			}.bind(this));
		},
		//Register
		register: function(){
			this.loading = true;
			this.register_data.error = '';
			var error = false;
			
			if(this.register_data.password != this.register_data.password_repeat){
				this.register_data.error = this.getLocale('error_different_password');
				error = true;
			}
			
			if(this.register_data.password.length < 6){
				this.register_data.error = this.getLocale('error_short_password');
				error = true;
			}
			
			if(!this.validateEmail(this.register_data.email)){
				this.register_data.error = this.getLocale('error_invalid_email');
				error = true;
			}
			
			if(this.register_data.username.length < 6){
				this.register_data.error = this.getLocale('error_invalid_username');
				error = true;
			}
			
			if(!error){
				var data = {
					type : 'register',
					data : {
						username : this.register_data.username,
						password : this.register_data.password,
						email : this.register_data.email,
						newsletter : this.register_data.newsletter
					}
				}
				
				browser.runtime.sendMessage(data, function(response) {
					if(response.success){
						this.panel = 'logged_in';
						this.first_login = true;
						this.username = response.message;
					}else{
						this.register_data.error = response.message;
					}
					this.loading = false;
				}.bind(this));	
			}else{
				this.loading = false;
			}
		},
		reconnect(){
			this.loading = true;
			this.login_data.error = '';
			
			browser.runtime.sendMessage({ type : 'reconnect' }, function(response) {
				if(response.success){
					this.panel = 'logged_in';
					this.username = response.message;
				}else{
					this.login_data.error = response.message;
				}
				this.loading = false;
			}.bind(this));
		}
	},
	components: {
		VButton
	}
	
}
</script>

<style lang="scss" scoped>
	@import "../styles/variables";
	@import "../styles/styles";
	
	body{
		overflow: hidden;
	}
	
	.popup{
		position: relative;
		padding: 20px 10px;
		overflow: hidden;
		
		h3{
			font-family: The Hustle;
			font-size: 50px;
			margin: 0;
			text-transform: lowercase;
		}
		
		a{
			text-decoration: none;
			cursor: pointer;
			color: $lightestazure;
		}
	
		label{
			margin-left: 10px;
		}
		
		.loading-wrapper{
			position: absolute;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			background-color: rgba(0,0,0,0.8);
			z-index: 10;
			
			.loading{
				position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
			}
		}
		
		.panel-container{
			position: relative;
			
			.panel{
				min-width: 250px;
				
				&.loggedin{
					.button{
						width: 150px !important;
					}
				}
			}
			
			
			.panel{
				width: 265px;
					
				.tabs{
					margin: 10px 0 20px;
					
					.tab{
						color: $darkazure;
						cursor: pointer;
						
						&:hover{
							color: $lightestazure;
						}
						
						&.current{
							color: $lightestazure;
							cursor: normal;
							
						}
					}
				}
				.actions{
					margin-top: 20px;
					
					.button{
						width: 100%;
					}
					
					.register{
						margin-top: 10px;
						
						a:hover{
							text-decoration: underline;
						}
					}
				}
				input[type=text],
				input[type=email],
				input[type=password]{
					display: block;
					margin-bottom: 5px;
					padding: 5px;	
					width: 100%;
				}
				
				.status{
					position: relative;
					background-color: black;
					height: 35px;
					width: 70px;
					border-radius: 17.5px;
					cursor: pointer;
					
					.toggle{
						position: absolute;
						left: 35px;
						height: 35px;
						width: 35px;
						border-radius: 50%;
						background-color: $green;
						box-shadow: 0px 0px 15px 0px $green;
						transition: left 0.18s;
					}
					
					&.active{
						.toggle{
							left: 0;
							background-color: $darkred;
							box-shadow: none;
						}
					}
				}
			}
		}
		
		.login-error,
		.register-error{
			margin: 0 -10px;
			padding: 10px 20px;
			color: white;
			text-align: center;
			transform: translateY(20px);
			max-width: 290px;
		}
	}


	/* LOADING */

	.loading .dot {
		width: 7px;
		height: 7px;
		background-color: white;
		border-radius: 50%;
		float: left;
		margin: 0 5px;
		-webkit-transform: scale(0);
		transform: scale(0);
		-webkit-animation: fx 1000ms ease infinite 0ms;
				animation: fx 1000ms ease infinite 0ms;
	}
	.loading .dot:nth-child(2) {
		-webkit-animation: fx 1000ms ease infinite 300ms;
				animation: fx 1000ms ease infinite 300ms;
	}
	.loading .dot:nth-child(3) {
		-webkit-animation: fx 1000ms ease infinite 600ms;
				animation: fx 1000ms ease infinite 600ms;
	}
	@-webkit-keyframes fx { 50% { -webkit-transform: scale(1); transform: scale(1); opacity: 1; } 100% { opacity: 0; } }
	@keyframes fx { 50% {  -webkit-transform: scale(1); transform: scale(1); opacity: 1; } 100% { opacity: 0; } }
</style>
